# dlCount 的作用

在下载器内部的抓取结果里，保存有 `dlCount` 属性。它用来记录从这个作品里下载前几张图片。

一个插画和漫画作品里可以有多张图片，如果用户启用了“多图作品只下载前几张图片”，下载器可以只下载前几张。

# 用于生成抓取结果

例如一个作品有 10 张图片，用户设置了只下载前 2 张，这个作品的 `dlCount` 就是 `2`。

当 `addResult` 方法添加抓取结果时，因为这个作品的 `dlCount` 是 `2`，所以下载器会生成这个作品前 2 张图片的数据，也就是生成 2 个结果。

# 用于生成文件名

当 `getFileName` 方法生成文件名时，如果用户启用了“为每个作品创建单独的文件夹”，就要读取抓取结果里的 `dlCount` 属性，判断是否应该因为此设置而创建一层文件夹。

# 补充

把 `dlCount` 保存在抓取结果里有些显得有些怪异，因为它并不是作品数据的一部分，而是一个用于其他目的的属性。

但是这是必要的，因为 `dlCount` 的值受“多图作品只下载前几张图片”设置的影响，但这个设置可能会被用户改变。

如果抓取时和下载时的该设置不同，那么生成的 `dlCount` 也不同，这就会出现问题。

--------

例如，用户设置了下载前 2 张图片，并且如果一个作品里下载的文件数量 > 1，就创建单独的文件夹。

那么 `dlCount` 是 `2` 的作品应该创建单独的文件夹。

但是在下载时，用户可能修改设置，只下载前 1 张图片。此时如果计算 `dlCount`，那么结果是 1，也就不应该创建单独的文件夹。

这样就产生了问题。

所以 `dlCount` 应该以生成抓取结果时为准，而不是在以后动态计算。

所以下载器必须在生成抓取结果时，把 `dlCount` 保存在抓取结果里，以备以后使用。
