# 已知问题

## 进度条显示总体积为 0 KiB

偶尔会发生这个情况：

下载器的某个进度条看上去是正常的，下载也没有出现问题，除了一个问题：这个文件的总体积显示为 0 KiB。

这个问题的原因在于 Pixiv。当下载器从 Pixiv 下载图片时，如果这次 HTTP 的返回头里没有 `content-length` 标签，就会出现这个问题。

这是随机的，所有图片文件都可能出现这个问题。

即使对于同一个文件，也有可能这次下载是正常的，下一次下载就出现这个问题：没有 `content-length` 标签。

```js
xhr.onprogress = function(event) {
  // event.loaded - how many bytes downloaded
  // event.lengthComputable = true if the server sent Content-Length header
  // event.total - total number of bytes (if lengthComputable)
}
```

下载器使用 xhr 对象的 `event.total` 来作为文件的总体积。如果缺少 `content-length` 标签，就会出现这个问题。