# 下载小说里的内嵌图片

小说里可以插入（内嵌）2 种图片：

1. 直接上传图片
2. 引用一个图像作品的 id

在 pixiv 的页面上，小说显示出来后，内嵌的图片上都有一个超链接。
- 上传的图片：img 不是原图，是压缩过的。超链接是原图。
- 引用的图片：img 是引用的作品里的第一张图片的原图。超链接是作品网址。

不过下载器不需要关心页面上显示出来的这些内容。

## 示例小说

https://www.pixiv.net/novel/show.php?id=18016618

作品数据里的关键数据如下：

```js
body: {
  content: `塔菲，你个臭粉毛，哼啊啊啊啊啊

上传的插画
[uploadedimage:13309543]

通过作品 id 插入的插画
[pixivimage:99381250]`,

  textEmbeddedImages: {
    "13309543": {
        "novelImageId": "13309543",
        "sl": "0",
        "urls": {
            "240mw": "https://i.pximg.net/c/240x480_80/novel-cover-master/img/2022/07/24/06/19/26/tei345516131740_1fd8644bc2575f1f1384075aab1f0bed_master1200.jpg",
            "480mw": "https://i.pximg.net/c/480x960/novel-cover-master/img/2022/07/24/06/19/26/tei345516131740_1fd8644bc2575f1f1384075aab1f0bed_master1200.jpg",
            "1200x1200": "https://i.pximg.net/c/1200x1200/novel-cover-master/img/2022/07/24/06/19/26/tei345516131740_1fd8644bc2575f1f1384075aab1f0bed_master1200.jpg",
            "128x128": "https://i.pximg.net/c/128x128/novel-cover-master/img/2022/07/24/06/19/26/tei345516131740_1fd8644bc2575f1f1384075aab1f0bed_square1200.jpg",
            "original": "https://i.pximg.net/novel-cover-original/img/2022/07/24/06/19/26/tei345516131740_1fd8644bc2575f1f1384075aab1f0bed.png"
        }
    }
  }
}
```

## 直接上传的图片

`[uploadedimage:13309543]` 这种标记是上传的图片。在 `body.textEmbeddedImages` 里有对应的数据，通过 `urls` 对象取出里面储存的网址即可。

## 引用作品的图片

`[pixivimage:99381250]` 这种标记是引用作品的图片。小说数据里没有它对应的网址，需要下载器自行获取其网址。

此外，pixiv 允许引用作品中某一张特定的图片，例如 `[pixivimage:99760571-1]` 最后面的 1 就是第 1 张图片。（等于是这个作品的 p0）。

有这个特征的小说如：https://www.pixiv.net/novel/show.php?id=17968738

## 小说保存格式为 EPUB 时

EPUB 可以内嵌图片，所以我把图片转换为 DataURL，使用 img 标签保存在 EPUB 里。

## 小说保存格式为 TXT 时

因为 TXT 不能内嵌图片，所以图片会随 txt 文件一同下载和保存。
