# 状态说明

`DownloadStates` 类保存有每个下载任务的状态：

```
// -1 未开始下载
// 0 下载中
// 1 下载完成
```

# 下载前

如果是全新的下载，则把所有任务的状态设为 `-1`。

如果之前暂停了下载，或者是由断点续传恢复的下载，则需要继续下载。此时调用 `downloadStates.resume()`，将“下载中” `0` 复位到“未开始下载” `-1 `，然后进入下载。

# 下载中

`DownloadControl` 类通过 `new Download` 创建一个下载任务，并把这个任务的状态改为 `0`。

之后在下载过程中：

- 跳过下载的，先触发 `EVT.events.skipSaveFile`，`DownloadControl` 监听到这个事件后会触发 `EVT.events.downloadSucccess` 事件，视为已下载。状态变为 `1`。
- Download 里文件下载失败的，触发 `EVT.events.downloadError` 事件。状态不变。
- Download 文件下载成功的，会把文件传递给后台保存到硬盘里，之后 `DownloadControl` 根据后台是否成功保存了文件，触发 `EVT.events.downloadSucccess` 事件（状态变为 `1`）或者 `EVT.events.saveFileError` 事件（状态复位成 `-1`，再次创建这个下载任务）。
