稍微研究一下作品收藏数量的增长速度，为“日均收藏数量”收集一些数据。

目的：当一个作品的发表时间不足 24 小时的时候时，尝试推测其在达到 24 小时时的收藏数量。

# 已废弃

这个实验已经作废，下文不需要再看了。

直接原因：我在 Pixiv 页面的控制台运行脚本，然后去睡觉了。结果 Windows 10 在我没有使用电脑的这段“空闲时间”自动安装更新并重启了系统，脚本自然也中断了，没能继续收集数据。Win 10 狗屎的更新机制不得不品尝。

其他原因：我想起来增长速度（曲线）和作品发布的时间也有关系，这导致事情变得更复杂了。如果某个作品发表时 Pixiv 的在线人数较少（比如深夜了大家都去睡觉了），另一个作品发表时在线人数很多，那么这两个作品的收藏数量增长曲线应该是不一样的。

根据 Pixiv 的公告 [pixiv的用户数突破5000万人   2020年5月27日](https://www.pixiv.net/info.php?cid=1&lang=zh&p=2)显示，截止 2020 年 4 月 28 日，Pixiv 活跃用户中的海外用户比例超过了 40%，那么东亚地区（日本国内加上中国、韩国等国家）的用户数量占比应该更高一些。

如果一个作品在北京时间 0 点发布，东亚地区的大部分人都睡觉了。在此后的几个小时里，Pixiv 的在线人数应该是越来越低的，其收藏数量的增长曲线可能是下降的。如果这个作品改为在人多的时候发表，它在几个小时内的收藏数量曲线可能是上升的。

所以这个实验的目的是很难达到的，不再继续研究了。

-----------

# 前言

今天是周四的半夜。我写了一个脚本，每 15 分钟收集一次指定作品的收藏数量。

提示：
- 代码在本文件夹下的 `getBmkData.js`
- 需要手动修改要测试的作品的 id
- 选择的样本收藏数量较高。这是考虑到“日均收藏数量”这个过滤器的目的是筛选出较高质量的图片，所以这个测试也只测试收藏数量较高的作品。

# 样本

## 样本 1

一个刚发表的作品 [91928804](https://www.pixiv.net/artworks/91928804)。画师 水々。

这位画师的作品质量较高，也有一定人气，不过还没到顶级人气。作为参考，他之前发表的几个作品的收藏数据如下：

```
作品发表之后经过的月数  收藏数量

2   6300
3   2600
4   4000
5   2300
6   2300
7   4000
```

## 样本 2

一个刚发表的作品 [91928938](https://www.pixiv.net/artworks/91928938)。画师 色谷あすか。

这位画师的人气比样本 1 的画师高很多。一些历史作品数据：

```
作品发表之后经过的月数  收藏数量

1   5000
2   9000
3   8000
4   4500
5   12000
7   6200
10  12000
```

## 样本 3

一个刚发表的作品 [91929446](https://www.pixiv.net/artworks/91929446)。画师 天音るり。

这位画师的人气比样本 1 的画师略高一些。一些历史作品数据：

```
作品发表之后经过的月数  收藏数量

15天  5800
2   2200
3   5600
5   7000
6   4000
```

## 样本 4

一个刚发表的作品 [91929592](https://www.pixiv.net/artworks/91929592)。画师 ゆき恵。

这位画师的人气比样本 1 的画师略高一些。一些历史作品数据：

```
作品发表之后经过的月数  收藏数量

10天  2000
3   4300
6   4000
8   4000
```

## 样本 5

一个刚发表的作品 [91930077](https://www.pixiv.net/artworks/91930077)。画师 Rinhee。

这位画师的人气比样本 1 的画师高很多。一些历史作品数据：

```
作品发表之后经过的月数  收藏数量

1   11000
2   6000
3   9000
4   7000
5   7000
6   20000
7   10000
```

# 数据

上面这些作品，我在其发表 10 分钟左右开始记录它们的数据。每个作品发表了 24 小时之后，数据如下。

