# 作品缩略图的选择器列表-小说作品

因为添加了“点击收藏按钮时下载作品”的功能，所以我打算获取小说的缩略图（主要是为了获取它的收藏按钮）。

这或许对“手动选择作品”也有帮助。因为现在在手动选择作品时，要求鼠标点击的元素包含作品链接,但是小说的链接就只有封面和标题，在其他部分点击的话是没效果的。如果能够从缩略图获取，或许能改善这个问题。

1. 由于 Pixiv 新版元素的 className 是动态生成的，所以不应该依赖具体的 className。
2. 由于要从动态添加的元素里获取缩略图，所以选择器路径应该尽量短一些。
3. 有些选择器会选择到图像作品，需要注意加以区别。
4. 如果有些页面只有一种列表，应该手动指定它所使用的选择器，以免被其他选择器错误的选择

| 选择器                              | 对应元素                                                                                     |
| ----------------------------------- | -------------------------------------------------------------------------------------------- |
| `section li>div`                    | 新版页面里大部分小说列表（没特别说明的都用这个）                                             |
| `li>div[size="392"]`                | 用户主页的小说列表、关注的用户的新作小说列表 div，与上面的选择器相同但带有 `size="392"` 属性 |
| `nav>div>div`                       | 小说页面内，正文下面横排的 3 个小说列表                                                      |
| `div.gtm-novel-work-recommend-link` | 小说页面内，相关作品里的小说列表                                                             |
| `li[size="1"]>div`                  | 首页里的大部分小说列表                                                                       |
| `div._ranking-item`                 | 小说排行榜里的列表                                                                           |
| `section ul>div`                    | 关注页面里的小说列表                                                                         |
| `section ul>li`                     | 系列小说页面里的小说列表                                                                     |
| `div[size="496"]`                   | 发现页面里收藏小说后，下面弹出的推荐作品                                                     |

小说缩略图的选取比图像作品的缩略图要麻烦，因为小说的很多 `li`、`div` 没有特殊标记，不像作品元素很多都有 width `div[width="90"]`。

---------------

已经测试没有问题的页面：

- 首页
- 用户主页
- 小说页面内
- 系列小说页面
- 小说排行榜
- 小说搜索页面
- 发现页面
- 已关注用户的新作品
- 大家的新作品
- 关注页面
- 约稿页面

所有含有小说的页面测试完毕。
