## 网址

一个有设定资料的系列小说示例：

https://www.pixiv.net/novel/series/8102333/glossary

带有图片的设定资料示例：

https://www.pixiv.net/novel/series/1459120/glossary/58972

## 层级

设定资料有三个层级：

1. 资料的分类
2. 资料
3. 资料的详情

## 页面元素

在页面元素里可以查找到对应的超链接元素：

```css
nav a[href$="glossary"]
```

## API 1

API 1 网址示例：

```
https://www.pixiv.net/ajax/novel/series/8913386/glossary
```

它可以获取所有的资料分类，以及每条资料的概述，但是不包含每条资料的详情。

返回值示例：

设定资料储存在 `categories` 里。如果这个系列小说没有设定资料，则 `categories` 是空数组 `[]`。

```json
{
    "error": false,
    "message": "",
    "body": {
        "categories": [
            {
                "id": "69024",
                "seriesId": "8913386",
                "name": "適当登場人物紹介(随時更新)",
                "items": [
                    {
                        "id": "149492",
                        "seriesId": "8913386",
                        "categoryId": "69024",
                        "name": "灰谷蓮華",
                        "overview": "前世は死因が過労とドーピングの悲しき企業戦士シングルファーザー。今世はスーパー問題児2人を抱えるシングルブラザー。",
                        "coverImage": {
                            "novelImageId": "8527",
                            "sl": "0",
                            "urls": {
                                "240mw": "https://i.pximg.net/c/240x480_80/novel-cover-master/img/2021/01/14/10/11/15/gic58955_c81cc23a772dc36418c3fb9fb20488f4_master1200.jpg",
                                "480mw": "https://i.pximg.net/c/480x960/novel-cover-master/img/2021/01/14/10/11/15/gic58955_c81cc23a772dc36418c3fb9fb20488f4_master1200.jpg",
                                "1200x1200": "https://i.pximg.net/c/1200x1200/novel-cover-master/img/2021/01/14/10/11/15/gic58955_c81cc23a772dc36418c3fb9fb20488f4_master1200.jpg",
                                "128x128": "https://i.pximg.net/c/128x128/novel-cover-master/img/2021/01/14/10/11/15/gic58955_c81cc23a772dc36418c3fb9fb20488f4_square1200.jpg",
                                "original": "https://i.pximg.net/novel-cover-original/img/2021/01/14/10/11/15/gic58955_c81cc23a772dc36418c3fb9fb20488f4.png"
                            }
                        },
                        "detail": null
                    },
                    {
                        "id": "149493",
                        "seriesId": "8913386",
                        "categoryId": "69024",
                        "name": "灰谷蘭",
                        "overview": "好きな食べ物は蓮華のホットケーキ",
                        "coverImage": null,
                        "detail": null
                    },
                    {
                        "id": "149494",
                        "seriesId": "8913386",
                        "categoryId": "69024",
                        "name": "灰谷竜胆",
                        "overview": "末っ子のくせに1番筋肉あるから兄2人に妬まれてる",
                        "coverImage": null,
                        "detail": null
                    },
                    {
                        "id": "149495",
                        "seriesId": "8913386",
                        "categoryId": "69024",
                        "name": "羽宮一虎",
                        "overview": "この前夜の街でおじさんに声をかけられた(そのことを蓮華に話した後おじさんを見た者は居ない)",
                        "coverImage": null,
                        "detail": null
                    },
                    {
                        "id": "149497",
                        "seriesId": "8913386",
                        "categoryId": "69024",
                        "name": "場地圭介",
                        "overview": "俺らの大天使バジエル",
                        "coverImage": null,
                        "detail": null
                    },
                    {
                        "id": "149499",
                        "seriesId": "8913386",
                        "categoryId": "69024",
                        "name": "九井一",
                        "overview": "金で愛は買えないことを知った少年",
                        "coverImage": null,
                        "detail": null
                    },
                    {
                        "id": "149502",
                        "seriesId": "8913386",
                        "categoryId": "69024",
                        "name": "明司武臣",
                        "overview": "ダメ兄まっしぐら()",
                        "coverImage": null,
                        "detail": null
                    },
                    {
                        "id": "149504",
                        "seriesId": "8913386",
                        "categoryId": "69024",
                        "name": "明司春千夜",
                        "overview": "家出先はだいたい蓮華の家",
                        "coverImage": null,
                        "detail": null
                    },
                    {
                        "id": "149510",
                        "seriesId": "8913386",
                        "categoryId": "69024",
                        "name": "明司千壽",
                        "overview": "蓮華のことは兄と言うよりママとして認識",
                        "coverImage": null,
                        "detail": null
                    }
                ]
            }
        ],
        "replaceeItemIds": [],
        "extraData": {
            "meta": {
                "title": "「灰谷長兄(仮)と弟(多数)たち」/「微茶」的系列作品 [pixiv]",
                "description": "這是灰谷長兄(仮)と弟(多数)たち的設定資料。適当登場人物紹介(随時更新)等",
                "canonical": "https://www.pixiv.net/novel/series/8913386/glossary",
                "ogp": {
                    "type": "article",
                    "title": "「灰谷長兄(仮)と弟(多数)たち」/「微茶」的系列作品 [pixiv]",
                    "description": "這是灰谷長兄(仮)と弟(多数)たち的設定資料。適当登場人物紹介(随時更新)等",
                    "image": "https://embed.pixiv.net/novel_series.php?id=8913386&mdate=20220527083159"
                },
                "twitter": {
                    "card": "summary_large_image",
                    "site": "@pixiv",
                    "title": "灰谷長兄(仮)と弟(多数)たち",
                    "description": "シングルファーザーだった前世の死因が過労とドーピングと言う悲しき企業戦士、灰谷長兄(仮)がたくさんの弟とキャッキャウフフするだけの話。 思い付き見切り発車なのでいつでも打ち切れます悪しからず。",
                    "image": "https://embed.pixiv.net/novel_series.php?id=8913386&mdate=20220527083159"
                }
            }
        },
        "zoneConfig": {
            "header": {
                "url": "https://pixon.ads-pixiv.net/show?zone_id=header&format=js&s=1&up=0&a=26&ng=g&l=zh_tw&uri=%2Fajax%2Fnovel%2Fseries%2F_PARAM_%2Fglossary&is_spa=1&K=149f195a38112&ab_test_digits_first=85&uab=26&yuid=cFeRFlA&suid=Ph3lmxjbmo0gvmbeq&num=62b7fe4a305&p=2&p=4&t=m3EJRa33xU"
            },
            "footer": {
                "url": "https://pixon.ads-pixiv.net/show?zone_id=footer&format=js&s=1&up=0&a=26&ng=g&l=zh_tw&uri=%2Fajax%2Fnovel%2Fseries%2F_PARAM_%2Fglossary&is_spa=1&K=149f195a38112&ab_test_digits_first=85&uab=26&yuid=cFeRFlA&suid=Ph3lmxjbmvaezh49y&num=62b7fe4a909&p=2&p=4&t=m3EJRa33xU"
            }
        }
    }
}
```

## API 2

API 2 请求资料的 id，用于获取资料的详情。

一次只能请求一条资料，格式如：

```
https://www.pixiv.net/ajax/novel/series/8913386/glossary/item/149492
```

返回值示例：

重点数据是返回值里的 `detail` 字段。

```json
{
    "error": false,
    "message": "",
    "body": {
        "item": {
            "id": "149492",
            "seriesId": "8913386",
            "categoryId": "69024",
            "name": "灰谷蓮華",
            "overview": "前世は死因が過労とドーピングの悲しき企業戦士シングルファーザー。今世はスーパー問題児2人を抱えるシングルブラザー。",
            "coverImage": null,
            "detail": "\nファンブック風プロフィール\n\n◆身長 175cm  ◆体重 60kg\n◆誕生日 4月のどっか  ◆星座 おうし座\n◆血液型 O型  ◆イメージカラー 紫(蓮華草の色)\n◆好きなもの 旅、子ども  ◆嫌いなもの 理不尽、不当な労働、虐待\n◆特技 家事全般、メイク\n◆尊敬する人、憧れの先輩 前世の妻  \n◆苦手な人、怖い人 嫌な上司と言う人種、今牛若狭\n◆夢 お手製キャンピングカーで日本一周\n◆ 武勇伝(または失敗談) 中学生時代に達観しすぎていたせいで先生たちの相談に乗ったり学校に来る不良を従えて上手いこと良い方向に促したりしてたら崇拝されてて卒業を惜しまれた。\n◆お気に入りの場所 マスターの店の1番奥の席、新居の自室\n\n\n灰谷兄弟とは再従兄弟(はとこ)の関係。\n前世は有能な企業戦士だった。ブラックな職場で仕事を押し付けられることが多く、娘のためならそんな苦行も大丈夫と笑えてしまった鋼のメンタルの持ち主。それ故に今世はそこまで他人に心を配らないよう気を付けているが、子どもの助けを求める声には超敏感。ああだこうだ言いながら手を差し伸べてしまう優しい性格。\nだがだいたいのことは暴力で解決しようとする脳筋。前世で色々考えるのが面倒になったからめんどくなると拳が出る。"
        },
        "extraData": {
            "meta": {
                "title": "灰谷蓮華 / 灰谷長兄(仮)と弟(多数)たち的设定资料 [pixiv]",
                "description": "前世は死因が過労とドーピングの悲しき企業戦士シングルファーザー。今世はスーパー問題児2人を抱えるシングルブラザー。",
                "canonical": "https://www.pixiv.net/novel/series/8913386/glossary/149492",
                "ogp": {
                    "type": "article",
                    "title": "灰谷蓮華 / 灰谷長兄(仮)と弟(多数)たち的设定资料 [pixiv]",
                    "description": "前世は死因が過労とドーピングの悲しき企業戦士シングルファーザー。今世はスーパー問題児2人を抱えるシングルブラザー。",
                    "image": "https://embed.pixiv.net/novel_series.php?id=8913386&mdate=20220527083159"
                },
                "twitter": {
                    "card": "summary_large_image",
                    "site": "@pixiv",
                    "title": "灰谷蓮華/灰谷長兄(仮)と弟(多数)たち",
                    "description": "前世は死因が過労とドーピングの悲しき企業戦士シングルファーザー。今世はスーパー問題児2人を抱えるシングルブラザー。",
                    "image": "https://embed.pixiv.net/novel_series.php?id=8913386&mdate=20220527083159"
                }
            }
        },
        "zoneConfig": {
            "header": {
                "url": "https://pixon.ads-pixiv.net/show?zone_id=header&format=js&s=1&up=0&a=26&ng=g&l=zh&uri=%2Fajax%2Fnovel%2Fseries%2F_PARAM_%2Fglossary%2Fitem%2F_PARAM_&is_spa=1&K=149f195a38112&ab_test_digits_first=85&uab=26&yuid=cFeRFlA&suid=Ph3omd1nszfvlsmq4&num=62bb6576862&p=2&p=4&t=m3EJRa33xU"
            },
            "footer": {
                "url": "https://pixon.ads-pixiv.net/show?zone_id=footer&format=js&s=1&up=0&a=26&ng=g&l=zh&uri=%2Fajax%2Fnovel%2Fseries%2F_PARAM_%2Fglossary%2Fitem%2F_PARAM_&is_spa=1&K=149f195a38112&ab_test_digits_first=85&uab=26&yuid=cFeRFlA&suid=Ph3omd1nt3jqbir0g&num=62bb6576812&p=2&p=4&t=m3EJRa33xU"
            }
        }
    }
}
```