# 小说封面图片的一些研究

## 尺寸

Pixiv 会对上传的小说封面图片进行裁剪，使其最大宽高不超过 600*600 px。

封面图都是 jpg 格式，平均体积大约在 200KB 左右。

目前无法获取未被裁剪的原图。

## URL

所有小说封面的 URL 都是不同的。

首先，有很多小说用的是系统提供的封面图片，但是 pixiv 会在图片上叠加标题文字，合成一张新的图片，所以这些图片都是不同的图片。既然图片文件都不一样，URL 自然也不一样。

其次，如果我们上传自己制作的封面，那么 pixiv 不会叠加文字，但是如果我们把这个封面上传到多个小说里，它们的 URL 也是不同的。

下面是我做的测试，把一个自己做的封面上传到两个小说里，URL 的如下：

```js
"https://i.pximg.net/c/600x600/novel-cover-master/img/2022/07/16/16/40/08/ci17967034_6f6b742681ac1ff7f0effbcb7f94a67a_master1200.jpg",
"https://i.pximg.net/c/600x600/novel-cover-master/img/2022/07/16/16/39/28/ci17967032_adbd09bd505b471af19e2bda9b5b0c36_master1200.jpg",
```

可以看到 URL 的格式是固定的，在 `novel-cover-master/img/` 后面有一些内容：
1. 图片被上传时的日期，精确到秒 `2022/07/16/16/40/08/`
2. 作品 id `ci17967034`
3. 还有一串随机字符。

可以看到封面 URL 里有一些唯一性的标记，所以不同小说的封面图片，其 URL 必定是不同的。