# 收藏页面的加载时间太久的问题

在 2023 年 1 月初，有人问我为什么在 pixiv 的收藏页面，点击一个标签后需要等待很久才会显示对应的作品。

我在我的收藏页面试了下，确实需要很久（20 秒以上），我向 pixiv 发送了一个反馈：

-------------------

收藏页面的加载总是花费太长时间

https://www.pixiv.net/users/9460149/bookmarks/artworks

在我的收藏页面中，点击任何一个标签，都需要至少 20 秒以上的时间才能加载出内容。

我录制了网络活动，发现两个主要问题：

1. 点击标签后，需要等待数秒钟，才会发起网络请求。为什么不是立刻？
2. 在前几个请求中，总会有一个请求卡住（pending），这个请求是不固定的，有时是 google-analytics.com 的脚本，有时是 google.com.hk 的脚本，最常见的情况是 pixon.ads-pixiv.net 的脚本…… 总之肯定会卡住几秒钟。为什么这些请求这么慢？
3. 我周围其他的 pixiv 用户有同样的问题。

我是中国区用户，使用代理访问 pixiv。网络没有异常，在收藏页面之外的其他地方一切正常。

这是录屏文件：
https://saber.love/f/2023-01-04%2018-27-32.mkv

-------------------

几天后 pixiv事务局 回信：

此次非常感谢您与我们提供信息。

非常抱歉您所告知内容可能是由于注册的书签标签数量很多。

我们会在调查后依次进行应对。

还请理解，应对时需要花费一些时间。

另外也请谅解，当应对结束，我们无法单独告知。

编辑编辑收藏，减少编辑收藏数量可能会改善此情况，烦请您尝试。

▼想要编辑收藏

https://www.pixiv.help/hc/articles/235585448

-------------------

看来主要问题在于我为这些收藏的作品添加的 **标签数量很多**。但是编辑页面并没有直接删除某个标签的功能，这使得就算用户想删除一些标签，也很麻烦。（目前只能点击一个标签，然后把它所属的作品全部取消收藏，才能达到删除标签的效果）。

我现在在我的收藏页面又试了几次，从点击标签到加载完毕只需要 13 秒，比之前快了几秒，不知道是 pixiv 已经做了优化，还是因为其他原因（比如时间段、服务器负载等）？以后还得观察。

如果过段时间情况没有改善，我可能需要添加一个“移除收藏作品的标签”的功能来解决此问题。
