- [文件名中不可使用的字符](#文件名中不可使用的字符)
  - [Windows 不允许使用的符号](#windows-不允许使用的符号)
  - [Chrome 不允许使用的符号](#chrome-不允许使用的符号)
  - [Window 保留名称](#window-保留名称)

# 文件名中不可使用的字符

本文中的“文件名”包含：

1. 文件夹名称（即路径）
2. 文件名称（不包含 `.` 分隔符和后缀名）

## Windows 不允许使用的符号

```
\
/
:
?
"
<
>
*
|
```

以上符号不能出现在文件名中。下载器会把它们替换为对应的全角符号。

## Chrome 不允许使用的符号

```
~
. （注 1）
```

Windows 允许 `~` 出现在文件名中，但是 Chrome 不允许。

window 允许 `.` 出现在文件名中，但是 Chrome 要求文件名**开头和结尾都不能使用 `.`**（文件名中间可以使用）。

下载器会把以上符号它们替换为对应的全角符号。

## Window 保留名称

Windows 中有一些保留名称：

- `CON` Keyboard and display
- `PRN` System list device, usually a parallel port
- `AUX` Auxiliary device, usually a serial port
- `NUL` Bit-bucket device
- `COM1` First serial communications port
- `LPT1` First parallel printer port
- `LPT2` Second parallel printer port
- `LPT3` Third parallel printer port
- `COM2` Second serial communications port
- `COM3` Third serial communications port
- `COM4` Fourth serial communications port

它们不区分大小写。

它们**不可以单独作为文件名**，必须搭配其他合法字符一起使用。

如果作为文件名，那么后缀名前面的部分需要单独处理。如 `con.txt` 是不合法的。

对于其处理方法，目前的决定是在其后添加特定的后缀字符。暂定为 `[downloader_add]`。

Window 保留名称这不适合替换成全角符号，那样会导致用户无法用修改后的结果搜索到出处。

测试用例：

1. 用户名为保留名字的情况，如果只使用命名规则 `{user}` 作为文件名（或路径名），则需要加以处理。

- [用户名为 con](https://www.pixiv.net/users/470827)
- [用户名为 CON](https://www.pixiv.net/users/3860015)
- [用户名为 aux](https://www.pixiv.net/users/25310111)

2. 页面 tag 为保留名字的情况，如果只使用命名规则 `{p_tag}` 作为文件名（或路径名），则需要加以处理。

- [页面 tag 为 PRN](https://www.pixiv.net/tags/PRN/artworks?s_mode=s_tag)