# 显示更大的缩略图

pixiv 显示的缩略图在很多页面上都显得比较小。这里研究下怎么让缩略图变大。

首先使用用户主页的作品列表来做测试。

https://www.pixiv.net/users/483730

## 步骤

首先要修改作品列表外部的容器的宽度设置为自适应。

它默认的宽度是 `width: 1224px;`。要设置它的宽度为 auto，并且 `min-width: 1224px;`。

然后再设置每个作品缩略图元素的宽度为 15%。

因为 pixiv 在多数页面上，一行显示 6 个作品缩略图，彼此之间还有间距，所以设置它们的宽度为 15% 并且 `min-width: 540px;`，让它们的宽度自适应。

最后设置缩略图里的一些元素，取消它们的宽高限制。（它们默认设置了宽高为 184px，现在设为 auto）。

## 如何生成样式表

pixiv 页面使用了模板编辑器生成，元素的 className 是可能会变的，所以如何生成样式表就成了个问题。

### 直接使用 className

```css
.fDaNEv{
  width: 15%;
}

.jDiQFZ{
  width: 100%;
}
```

直接使用页面上的 className，这样很简单。但是如果 className 变了，那么这个功能就失效了，必须修改代码，上传到应用商店更新，这样才能修复。

### 使用 js 获取每个元素

考虑使用 js 和 XPath 来获取某些特定元素，例如

获取列表外部容器：

```js
let root = document.querySelector('#root')
let r2 = document.evaluate("/html/body/div[2]/div[2]/div[2]/div/div[2]/div[3]/div/div", document, null, XPathResult.ANY_TYPE, null);
r2.iterateNext()
```

这样做非常麻烦，但是比较稳定。

它的复杂程度比上个方法麻烦很多：

1. 要使用 js 获取指定元素。但是由于 pixiv 页面里使用 className 作为选择器不可靠，所以不能用 className，这样选取特定元素很麻烦。
2. 不同页面类型里的 DOM 元素结构不一样，所以在不同页面里的获取方法可能也不同。这和 css 不一样，一套 css 在所有页面都能用。
3. 如果页面代码变化了，也有可能需要修改代码。

目前打算先用纯 css 的方法。

## 横图

一排显示 6 个缩略图的话，竖图显示效果很好，但是横图就不好了，因为宽度比较小，横图显示的也就比较小。和竖图相比较就很不平衡。

一个想法是把横图当做 2 个竖图处理，就是把它的宽度设置为竖图的 2 倍。这样效果确实好，但是实现起来比较麻烦。

目前实现了这个功能，但是只处理了常用的区域的横图。一些不常用区域的横图并没有处理，因为情况太多，处理起来很麻烦。

--------------

li[size="1"]

它里面的第 3 - 5 层子元素才是 div 184

- 画师主页的
- 作品页面下面的相关作品
- 收藏页面的作品
- 主页里一排 6 个的
- 发现页面的作品
- 关注的用户的新作品页面