# 替换方形缩略图

## 检查需要处理的缩略图元素

旧版页面都不需要处理，因为旧版页面里的缩略图本来就是保持原比例的。只有新版页面里的缩略图才是正方形。

首先根据页面类型来判断，只在新版页面里执行代码。

判断 img 标签是不是缩略图，然后对其 src 进行替换。

新版页面内大部分预览图都是这样：

```html
<img src="https://i.pximg.net/c/250x250_80_a2/custom-thumb/img/2021/10/26/00/00/08/93686259_p0_custom1200.jpg" alt="#オリジナル PA - STHK的插画" class="sc-rp5asc-10 erYaF" style="object-fit: cover; object-position: center center;">

<img src="https://i.pximg.net/c/250x250_80_a2/img-master/img/2019/06/23/17/29/27/75369283_square1200.jpg" alt="#动图 白面 - 光年的动图" class="sc-rp5asc-10 erYaF" style="object-fit: cover; object-position: center center;">

<img src="https://i.pximg.net/c/250x250_80_a2/img-master/img/2021/11/19/00/00/06/94219649_p0_square1200.jpg" alt="#オリジナル rkgk - EB十的插画" class="sc-rp5asc-10 zLpvh" style="object-fit: cover; object-position: center center;">

<img src="https://i.pximg.net/c/360x360_70/img-master/img/2021/11/26/23/05/57/94377830_p0_square1200.jpg" alt="#創作 アドベントな街 - ポ～ン（出水ぽすか）的插画" class="sc-rp5asc-10 erYaF" style="object-fit: cover; object-position: center center;">

<img src="https://i.pximg.net/c/540x540_70/custom-thumb/img/2021/11/26/21/00/01/94372718_p0_custom1200.jpg" alt="リクエスト凌辱ちゃん" class="sc-7bef31-2 bGXiIQ" style="object-fit: cover; object-position: center center;">
```

虽然元素很相似，但是缩略图的尺寸不尽相同，url 格式也有差别。

**注意：** 动图的缩略图没有序号 `_p0`！

判断 img 的 src 里是否含有 `square1200` 或者 `custom1200` 来确定它是不是方形缩略图。



如果是，则将 src 替换为 540px 尺寸的保持比例的缩略图，url 格式如：

```
https://i.pximg.net/c/540x540_70/img-master/img/2020/12/03/00/04/53/86056097_p0_master1200.jpg
```

此外，还有 240px 的缩略图，也是保持比例的，格式如下：

```
https://i.pximg.net/c/240x240/img-master/img/2021/04/17/08/30/01/89199745_p0_master1200.jpg
```

但是 240px 缩略图和 540px 缩略图的体积相差不大，而且 540px 在高分屏上效果会更好，所以使用 540px。

## 需要排除的图片

带有 `data-index` 属性的 img 元素是图片查看器底部的缩略图，现在是 250px 的正方形缩略图，不进行替换。

## 替换步骤

从方形缩略图的 url 里提取参数，填入 540px 缩略图的 url 中：

```
https://i.pximg.net/c/540x540_70/img-master/img/${datetime}/${id_index}_master1200.jpg
```

## 540px 缩略图对于多图作品的每一张图都有效

下载器在作品大图下方添加的缩略图标签，也是可以替换成 540px 的。

现在这些缩略图是方形的，url 格式如下：

```
https://i.pximg.net/c/250x250_80_a2/img-master/img/2021/11/28/18/19/20/94433121_p0_square1200.jpg
```


