# 测试边抓取边下载的方式花费的时间

边抓取边下载指的是 PixivUtil2 的工作方式，每次只请求 1 个作品数据，然后下载它。下载之后再开始抓取下一个作品的数据。（每个作品之间有 1 秒左右的延迟）

和之前的文档 `大量抓取时被 Pixiv 限制的情况的测试.md` 不同的是，之前的文档只测试了抓取时间，这个文档连同抓取+下载放在一起测试。

让下载器和 PixivUtil2 抓取、下载同样的作品，然后比较花费的时间。

下载器则设置为单线程抓取：每次只发送 1 个抓取请求（抓取列表页和抓取作品页时均为 1）。全部抓取之后，再集中下载。

记录从开始抓取到下载完毕所需的时间。

下载时，下载器设置为 3 个下载线程。PixivUtil2 只有 1 个下载线程。

# 测试 1

## 测试条件

抓取和下载这个画师的所有作品：https://www.pixiv.net/users/544479

共 264 个作品，383 个文件，体积 250 MB。

该标签页一直处于前台。

## 测试表现

下载器在抓取了 153 个作品后被限制而暂停一次。

下载器从开始抓取到下载完毕共 469 秒，接近 8 分钟。

----------------

在 PixivUtil2 的日志里，从开始抓取到下载完毕，时间为 17 分 9 秒。时间是下载器的 2 倍。

```
2022-08-18 04:51:24,165 - PixivUtil20220804 - INFO - Member IDs: ['544479']
2022-08-18 04:51:24,166 - PixivUtil20220804 - INFO - [33m[1mProcessing Member Id: 544479[0m

2022-08-18 05:08:33,864 - PixivUtil20220804 - INFO - Member_id: 544479 completed: last image_id: 2696272
```

# 测试 2

此测试作废。

## 测试条件

抓取和下载我的收藏的前 50 页。这里面单图、动图、多图都有。

预计一共有 50*48 = 2400 个作品。本来我想测试抓取更多页面的，但是 PixivUtil2 似乎不能设置为“多图作品只下载前一张图片”，导致下载器也只能下载所有的图片。这导致要下载的文件数量太多了，太费时间，我不得不减少抓取的页面。

动图都不转换。

共 2393 个作品，4653 个文件，体积 12.1 GB。

该标签页一直处于前台。

## 测试表现

下载器在抓取途中被限制而暂停 13 次。

```
215
367
585
757
918
1124
1280
1467
1603
1813
1963
2125
2323
```

预计时间约为 13*200+2393/5+13030/1.2 = 10858 秒。

下载器从开始抓取到下载完毕共 24063 秒，接近 6.7 个小时。实际上花了两倍的时间，我猜测是梯子抽风了，下载速度慢于预期。这个实验作废。

大量测试真的太费时间了。

# 测试 3

## 测试条件

抓取 2022年 8 月 16 日的排行榜：https://www.pixiv.net/ranking.php?mode=daily&content=illust&date=20220816

共 500 个作品，1193 个文件，体积 2.47 GB。

该标签页一直处于前台。

## 测试表现

下载器在抓取途中被限制而暂停 2 次。

```
159
393
```

下载器从开始抓取到下载完毕共 2772 秒，约 46 分钟。

----------------

PixivUtil2 这里出了一点意外，因为我是用它的可执行文件抓取时，不能设置排行榜的日期，所以抓取的是最新一天（2022年 8 月 17 日）的排行榜。

共 500 个作品，941 个文件，2.27 GB。

在 PixivUtil2 的日志里，从开始抓取到下载完毕，时间为 70 分钟。时间是下载器的 1.5 倍。

```
2022-08-18 18:30:56,478 - PixivUtil20220804 - INFO - Download Ranking by Post ID mode (15).

2022-08-18 19:40:26,645 - PixivUtil20220804 - INFO -  done.
```

我尝试估算一下 PixivUtil2 比下载器多花费的时间。（下载时的网速没有明显差别）

每下载一个作品，PixivUtil2 会等待 1 秒左右，所以等待时间一共 500 秒。

由于 PixivUtil2 是单线程下载，每个文件的网络请求都需要等待服务器响应，然后才能开始下载。假设每个响应时间花费 300 ms，那么 941 个文件大约花费 300 秒。

这样合计比下载器多花费 800 秒，不到 14 分钟。但实际比下载器多花了 24 分钟，比上面的计算多出 10 分钟。我不能确定具体原因，可能是因为在发送请求前还有一段延迟时间：

```ini
2022-08-18 18:39:57,699 - PixivUtil20220804 - DEBUG - Getting image page: 100516730
2022-08-18 18:39:58,294 - PixivUtil20220804 - DEBUG - New UI Mode
2022-08-18 18:39:58,433 - PixivUtil20220804 - DEBUG - using webrpc: https://www.pixiv.net/rpc/get_work.php?id=100516730
```

第一行 `Getting image page` 到最后一行发送请求，中间隔了大约 700 ms。如果算上这个时间，那么总时间就对的上了。但是为什么会有这个延迟呢，我不清楚。

# 总结

PixivUtil2 现在的运行方式，所需的时间比下载器更久，但是不容易被限制。

我在想要不要把下载器的流程也改成这样试试效果。如果下载器这样做，需要的时间会比下载器现在的时间更多，但应该会短于 PixivUtil2 的时间。就是介于两者之间。

但是这需要比较多的修改，现在想到需要修改的有：

- 抓取流程
- 下载控制
- 断点续传。之前断点续传保存的是抓取后的数据，以及下载状态。修改后还需要保存抓取进度。
- 导出抓取结果。之前在抓取之后就可以导出完整的抓取结果了，修改之后需要等到完全下载完毕才能导出抓取结果。（因为下载完毕之前，没有获取到所有的作品数据）
- 与导出抓取结果受到相同影响的还有：导出 CSV 文件、自动导出抓取结果、预览文件名、复制 URL。
- 自动下载开关。之前用户可以自己选择是否自动下载，修改后必须全部自动下载，否则如果有几百几千个文件，让用户手动点开始下载按钮是不合适的。
- 开始下载、暂停下载、停止下载等按钮的功能需要变成开始抓取、暂停抓取、停止抓取。

上述修改不仅需要修改代码，还会改变用户长期以来的使用习惯，目前我觉得还是不要这样修改比较好。
