# 插画、漫画

## 尺寸

插画、漫画的图片有五种尺寸：

```
urls: {
  mini: string
  thumb: string
  small: string
  regular: string
  original: string
}
```


- mini 最小尺寸，有些多图作品只有第一张图有此尺寸。总是 48*48 的正方形，所以可能会裁剪掉图片的一些区域。
- thumb 缩略图，有些多图作品只有第一张图有此尺寸。总是 250*250 的正方形，所以可能会裁剪掉图片的一些区域。
- small 较小尺寸，所有图片都有此尺寸。尺寸上限为 540*540。如果原图不是正方形，会保留图片比例缩小到此范围。
- regular 普通尺寸，所有图片都有此尺寸。尺寸上限为 1200*1200。如果原图不是正方形，会保留图片比例缩小到此范围。
- original 原图，所有图片都有此尺寸

所以，为了确保能对所有图片生效，只能选择以下三个尺寸：

-  small
-  regular
-  original

为什么没有 mini 和 thumb 选项：

1. 多图作品可能只有第一张图有这两个尺寸，后续图片没有这两个尺寸。所以保持一致，不使用这两个尺寸。
2. 这两个尺寸总是固定大小的正方形，很可能会裁剪图片，导致看不到图片的全貌。

## 例子

https://www.pixiv.net/artworks/84773373

```
mini: "https://i.pximg.net/c/48x48/custom-thumb/img/2020/10/03/18/39/30/84773373_p0_custom1200.jpg"
original: "https://i.pximg.net/img-original/img/2020/10/03/18/39/30/84773373_p0.png"
regular: "https://i.pximg.net/img-master/img/2020/10/03/18/39/30/84773373_p0_master1200.jpg"
small: "https://i.pximg.net/c/540x540_70/img-master/img/2020/10/03/18/39/30/84773373_p0_master1200.jpg"
thumb: "https://i.pximg.net/c/250x250_80_a2/custom-thumb/img/2020/10/03/18/39/30/84773373_p0_custom1200.jpg"
```

# 动图

## 尺寸

动图也有上面五种尺寸，但是都是静态的。为了保留动态效果，不能采用这五种尺寸。

在 ugoira_meta 里，有两种尺寸：

```
originalSrc: "https://i.pximg.net/img-zip-ugoira/img/2020/10/12/10/19/38/84965766_ugoira1920x1080.zip"
src: "https://i.pximg.net/img-zip-ugoira/img/2020/10/12/10/19/38/84965766_ugoira600x600.zip"
```

- originalSrc 动图源文件压缩包
- src 图片尺寸缩小到不超过 600*600 的压缩包。

打开动图页面时，会显示 src 尺寸的，点击它才会显示原图尺寸。所以 src 尺寸在使用意义上对应插画、漫画的 regular 尺寸。

## 对应关系

动图压缩包的尺寸需要映射到插画、漫画的尺寸。

-  small 动图使用 src 尺寸
-  regular 动图使用 src 尺寸
-  original 动图使用 originalSrc 尺寸
